#if !defined(__COMMON_H__)
#define __COMMON_H__

#define VER	("0.1b")

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <time.h>
#include <unistd.h>
#include <signal.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#define MAX_BUFF_LEN		(16384)
#define MAX_USERNAME_LEN	(256)
#define MAX_PASSWORD_LEN	(256)
#define MAX_PROC			(20)
#define MAX_FILE_NAME_LEN	(256)

/*
 * 	network/http operations
 */

#define HG_ERR_SYS			(-1)
#define HG_ERR_UNRESOLVED	(-2)
#define HG_ERR_HTTP			(-3)

/*
 * 	debug stuff
 */

#ifdef DEBUG
#define DEBUGPR(c)  do { \
						 printf("debug: "); \
					     printf c; \
						 printf("\n"); \
					} while (0)
#else
#define DEBUGPR(c)	do {} while(0)
#endif


/*
 *  options stuff
 */
	
struct options {
	char			def_username[MAX_USERNAME_LEN];
	char			def_password[MAX_PASSWORD_LEN];
	char			proxy_server[256];
	char			dict_list_file[MAX_FILE_NAME_LEN];
	char			quick_dict[MAX_FILE_NAME_LEN];
	char			def_pass_dict[MAX_FILE_NAME_LEN];
	int				transf_value;
	unsigned short	proxy_port;
	unsigned int	flags;
	unsigned int	max_proc;
	int				req_delay;
};
#define	OPT_DEF_USER	(1)
#define OPT_DEF_PASS	(2)
#define OPT_NOTRANSF	(4)
#define OPT_DICT_COMBO	(8)
#define OPT_LOG			(16)
#define	OPT_PROXY		(32)
#define OPT_HTTP_GET	(64)
#define OPT_DEF_PASSES	(128)
#define OPT_TRANSF_LESS	(256)
#define OPT_LOG_NOCOMB	(512)

/*
 *  log file stuff
 */

#define wl_error	(1)
#define	wl_info		(2)
#define	wl_debug	(3)

/*
 * 	extern variables
 */

extern struct options opts;
extern char	  log_name[];
extern pid_t  main_pid;


/*
 * 	extern functs
 */

extern char* chomp(char*);
extern char* alltrim(char*);

extern int 	 write_log(char*, int, const char*, ...);
extern void* my_alloc(unsigned int);
extern void* my_realloc(void*, unsigned int);
extern int   process(char*);
extern void  fatal(const char*);
extern int   base64enc(char*, int, char*);
extern int   milisleep(int);
extern int   get_un_pw(char* un, char* pw);

#endif
