#if !defined(__HTTP_H__)
#define __HTTP_H__

#define MAX_SERVER_NAME_LEN   	(256)
#define MAX_LOCATION_LEN    	(2048)
#define MAX_URL_LEN		(MAX_SERVER_NAME_LEN+MAX_LOCATION_LEN+12)

#define HTTP_METHOD_GET		(1)
#define HTTP_METHOD_HEAD	(2)
#define HTTP_METHOD_POST	(3)

#define HTTP_CONNECT_TIMEOUT		(10)

typedef struct {
	char server[MAX_SERVER_NAME_LEN];
	char plain_url[MAX_URL_LEN];
	char proxy_server[MAX_SERVER_NAME_LEN];
	unsigned short proxy_port;
	unsigned short port;
	char location[MAX_LOCATION_LEN];
	char username[MAX_USERNAME_LEN];
	char password[MAX_PASSWORD_LEN];
}	http_url;

typedef struct {
	http_url*	url;
	int			method;
	char		user_agent[256];
	char		referer[MAX_URL_LEN];
	char		from[256];
	char		if_modified[256];
	char		auth[256];
	char*		body;
	int			body_len;
}	http_request;

typedef struct {
	unsigned int	status_code;
	unsigned int 	http_ver_major;
	unsigned int	http_ver_minor;
	char			reason_phrase[256];
	char			location[256];
	char			server[256];
	char			www_auth[256];
	char			content_type[256];
	char			date[256];
}	http_response;

extern int http_parse_url(const char*, http_url*);
extern int http_send(http_request*,  http_response*);
extern int http_init_request(http_request*, int);
extern unsigned get_bytes_read(), get_bytes_wrote();

#endif
